OpenTTD Source: VehicleGroupWindow Class Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes
VehicleGroupWindow Class Reference
Inheritance diagram for VehicleGroupWindow:

## Public Member Functions
| VehicleGroupWindow (WindowDesc &desc, WindowNumber window_number, const VehicleListIdentifier &vli)
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
void | OnPaint () override
| The window must be repainted.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnMouseLoop () override
| Called for every mouse loop run, which is at least once per (game) tick.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnDragDrop_Group (Point pt, WidgetID widget)
void | OnDragDrop_Vehicle (Point pt, WidgetID widget)
void | OnDragDrop (Point pt, WidgetID widget) override
| A dragged 'object' has been released.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | OnResize () override
| Called after the window got resized.
void | OnDropdownSelect (WidgetID widget, int index, int) override
| A dropdown option associated to this window has been selected.
void | OnGameTick () override
| Called once per (game) tick.
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
void | OnMouseDrag (Point pt, WidgetID widget) override
| An 'object' is being dragged at the provided position, highlight the target if possible.
void | ShowRenameGroupWindow (GroupID group, bool empty)
void | UnselectVehicle (VehicleID vehicle)
| Tests whether a given vehicle is selected in the window, and unselects it if necessary.
void | SelectGroup (const GroupID g_id)
| Selects the specified group in the list.
Public Member Functions inherited from BaseVehicleListWindow
| BaseVehicleListWindow (WindowDesc &desc, const VehicleListIdentifier &vli)
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | UpdateSortingFromGrouping ()
void | DrawVehicleListItems (VehicleID selected_vehicle, int line_height, const Rect &r) const
| Draw all the vehicle list items.
void | UpdateVehicleGroupBy (GroupBy group_by)
void | SortVehicleList ()
void | BuildVehicleList ()
void | SetCargoFilter (uint8_t index)
| Set cargo filter for the vehicle group list.
void | SetCargoFilterArray ()
| Populate the filter list and set the cargo filter criteria.
void | FilterVehicleList ()
| Filter the engine list against the currently selected cargo filter.
StringID | GetCargoFilterLabel (CargoType cargo_type) const
DropDownList | BuildCargoDropDownList (bool full) const
| Build drop down list for cargo filter selection.
Dimension | GetActionDropdownSize (bool show_autoreplace, bool show_group, bool show_create)
| Compute the size for the Action dropdown.
DropDownList | BuildActionDropdownList (bool show_autoreplace, bool show_group, bool show_create)
| Display the Action dropdown window.
std::span< const StringID > | GetVehicleSorterNames () const
std::span< VehicleGroupSortFunction *const > | GetVehicleSorterFuncs () const
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Static Public Member Functions
static void | DeleteGroupCallback (Window *win, bool confirmed)
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Private Member Functions
void | BuildGroupList (Owner owner)
| (Re)Build the group list.
uint | ComputeGroupInfoSize ()
| Compute tiny_step_height and column_size.
void | UpdateColumnRects ()
| Update precalculated column rects for drawing group information.
std::string | GetGroupNameString (GroupID g_id) const
| Get the string to draw for the given group.
SpriteID | GetGroupProfitSpriteID (GroupID g_id) const
| Get the profit sprite ID to draw for the given group.
void | DrawGroupInfo (Rect r, GroupID g_id, uint16_t level_mask=0, uint8_t indent=0, bool protection=false, bool has_children=false) const
| Draw a row in the group list.
void | DirtyHighlightedGroupWidget ()
| Mark the widget containing the currently highlighted group as dirty.

## Private Attributes
GroupID | group_sel = GroupID::Invalid()
| Selected group (for drag/drop)
GroupID | group_rename = GroupID::Invalid()
| Group being renamed, GroupID::Invalid() if none.
GroupID | group_over = GroupID::Invalid()
| Group over which a vehicle is dragged, GroupID::Invalid() if none.
GroupID | group_confirm = GroupID::Invalid()
| Group awaiting delete confirmation.
GUIGroupList | groups {}
| List of groups.
uint | tiny_step_height = 0
| Step height for the group list.
Scrollbar * | group_sb = nullptr
std::array< Dimension, VGC_END > | column_size {}
| Size of the columns in the group list.
std::array< Rect, VGC_END > | column_rects {}
bool | last_overlay_state = false

## Additional Inherited Members
Public Types inherited from BaseVehicleListWindow
enum | GroupBy : uint8_t { GB_NONE , GB_SHARED_ORDERS , GB_END }
enum | ActionDropdownItem : uint8_t { ADI_REPLACE , ADI_SERVICE , ADI_DEPOT , ADI_ADD_SHARED , ADI_REMOVE_ALL , ADI_CREATE_GROUP }
typedef GUIVehicleGroupList::SortFunction | VehicleGroupSortFunction
typedef GUIVehicleList::SortFunction | VehicleIndividualSortFunction
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Data Fields inherited from BaseVehicleListWindow
GroupBy | grouping {}
| How we want to group the list.
VehicleList | vehicles {}
| List of vehicles. This is the buffer for `vehgroups` to point into; if this is structurally modified, `vehgroups` must be rebuilt.
GUIVehicleGroupList | vehgroups {}
| List of (groups of) vehicles. This stores iterators of `vehicles`, and should be rebuilt if `vehicles` is structurally changed.
Listing * | sorting = nullptr
| Pointer to the vehicle type related sorting.
uint8_t | unitnumber_digits = 0
| The number of digits of the highest unit number.
Scrollbar * | vscroll = nullptr
VehicleListIdentifier | vli {}
| Identifier of the vehicle list we want to currently show.
VehicleID | vehicle_sel {}
| Selected vehicle.
CargoType | cargo_filter_criteria {}
| Selected cargo filter index.
uint | order_arrow_width = 0
| Width of the arrow in the small order list.
CargoTypes | used_cargoes {}
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}
Static Public Attributes inherited from BaseVehicleListWindow
static const StringID | vehicle_depot_name []
static const std::initializer_list< const StringID > | vehicle_group_by_names
static const std::initializer_list< const StringID > | vehicle_group_none_sorter_names_calendar
static const std::initializer_list< const StringID > | vehicle_group_none_sorter_names_wallclock
static const std::initializer_list< const StringID > | vehicle_group_shared_orders_sorter_names_calendar
static const std::initializer_list< const StringID > | vehicle_group_shared_orders_sorter_names_wallclock
static const std::initializer_list< VehicleGroupSortFunction *const > | vehicle_group_none_sorter_funcs
static const std::initializer_list< VehicleGroupSortFunction *const > | vehicle_group_shared_orders_sorter_funcs
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Detailed Description

Definition at line 208 of file group_gui.cpp.

## Constructor & Destructor Documentation

## ◆ VehicleGroupWindow()

VehicleGroupWindow::VehicleGroupWindow | ( | WindowDesc & | desc,
|  | WindowNumber | window_number,
|  | const VehicleListIdentifier & | vli
| ) |  |
| inline

Definition at line 421 of file group_gui.cpp.

## ◆ ~VehicleGroupWindow()

VehicleGroupWindow::~VehicleGroupWindow | ( |  | ) |
| inline

Definition at line 451 of file group_gui.cpp.

## Member Function Documentation

## ◆ BuildGroupList()

void VehicleGroupWindow::BuildGroupList | ( | Owner | owner | ) |
| inlineprivate

(Re)Build the group list.

Parameters

  owner | The owner of the window

Definition at line 227 of file group_gui.cpp.

References BuildGuiGroupList(), groups, GUIList< T, P, F >::NeedRebuild(), GUIList< T, P, F >::RebuildDone(), BaseVehicleListWindow::vli, and VehicleListIdentifier::vtype.

Referenced by OnPaint(), and SelectGroup().

## ◆ ComputeGroupInfoSize()

uint VehicleGroupWindow::ComputeGroupInfoSize | ( |  | ) |
| inlineprivate

Compute tiny_step_height and column_size.

Returns
  Total width required for the group list.

Definition at line 242 of file group_gui.cpp.

References ALL_GROUP, column_size, VehicleListIdentifier::company, WidgetDimensions::framerect, FS_SMALL, GetGroupNumVehicle(), GetParamMaxValue(), GetScaledSpriteSize(), GetString(), GetStringBoundingBox(), Window::height, WidgetDimensions::hsep_indent, WidgetDimensions::hsep_normal, WidgetDimensions::hsep_wide, maxdim(), WidgetDimensions::scaled, RectPadding::Vertical(), VGC_AUTOREPLACE, VGC_FOLD, VGC_NAME, VGC_NUMBER, VGC_PROFIT, VGC_PROTECT, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, and Window::width.

Referenced by UpdateWidgetSize().

## ◆ DeleteGroupCallback()

static void VehicleGroupWindow::DeleteGroupCallback | ( | Window * | win,
|  | bool | confirmed
| ) |  |
| inlinestatic

Definition at line 720 of file group_gui.cpp.

## ◆ DirtyHighlightedGroupWidget()

void VehicleGroupWindow::DirtyHighlightedGroupWidget | ( |  | ) |
| inlineprivate

Mark the widget containing the currently highlighted group as dirty.

Definition at line 407 of file group_gui.cpp.

References IsAllGroupID(), Window::SetWidgetDirty(), WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, and WID_GL_LIST_GROUP.

Referenced by OnMouseDrag(), and OnPlaceObjectAbort().

## ◆ DrawGroupInfo()

void VehicleGroupWindow::DrawGroupInfo | ( | Rect | r,
|  | GroupID | g_id,
|  | uint16_t | level_mask = `0`,
|  | uint8_t | indent = `0`,
|  | bool | protection = `false`,
|  | bool | has_children = `false`
| ) |  | const
| inlineprivate

Draw a row in the group list.

Parameters

  r | Rect to draw row in.
  g_id | Group to list.
  indent | Indentation level.
  protection | Whether autoreplace protection is set.
  has_children | Whether the group has children and should have a fold / unfold button.

Definition at line 341 of file group_gui.cpp.

References _current_text_dir, GroupStatistics::autoreplace_defined, GroupStatistics::autoreplace_finished, WidgetDimensions::bevel, CentreBounds(), Rect::CentreToHeight(), column_size, VehicleListIdentifier::company, DrawString(), FS_SMALL, WidgetDimensions::fullbevel, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::Get(), GroupStatistics::Get(), GetColourGradient(), GetGroupNumVehicle(), GetGroupProfitSpriteID(), GetString(), GfxFillRect(), HasBit(), WidgetDimensions::hsep_indent, Rect::Indent(), IsAllGroupID(), NEW_GROUP, GroupStatistics::num_vehicle, PALETTE_CRASH, SA_CENTER, SA_FORCE, SA_RIGHT, WidgetDimensions::scaled, Rect::Shrink(), TD_RTL, Rect::Translate(), VGC_AUTOREPLACE, VGC_FOLD, VGC_NAME, VGC_NUMBER, VGC_PROFIT, VGC_PROTECT, BaseVehicleListWindow::vli, Window::width, and Rect::WithX().

Referenced by DrawWidget().

## ◆ DrawWidget()

void VehicleGroupWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 637 of file group_gui.cpp.

References ALL_GROUP, WidgetDimensions::bevel, DEFAULT_GROUP, DrawGroupInfo(), Window::DrawSortButtonState(), DrawString(), BaseVehicleListWindow::DrawVehicleListItems(), FILLRECT_CHECKER, Group::flags, Group::folded, FS_NORMAL, GetCharacterHeight(), GetColourGradient(), Scrollbar::GetPosition(), GetString(), Scrollbar::GetVisibleRangeIterators(), GfxFillRect(), Vehicle::group_id, BaseVehicleListWindow::grouping, groups, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, GUIList< T, P, F >::IsDescSortOrder(), NEW_GROUP, Group::owner, ReplaceProtection, Window::resize, SA_RIGHT, SBS_DOWN, SBS_UP, WidgetDimensions::scaled, Rect::Shrink(), ResizeInfo::step_height, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), Rect::Translate(), TimerGameEconomy::UsingWallclockUnits(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicle_sel, BaseVehicleListWindow::vehicles, WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, WID_GL_INFO, WID_GL_LIST_GROUP, WID_GL_LIST_VEHICLE, WID_GL_SORT_BY_ORDER, and Rect::WithHeight().

## ◆ GetGroupNameString()

std::string VehicleGroupWindow::GetGroupNameString | ( | GroupID | g_id | ) | const
| inlineprivate

Get the string to draw for the given group.

Parameters

  g_id | Group to get string for.

Returns
  Formatted string to draw.

Definition at line 310 of file group_gui.cpp.

References GetString(), IsAllGroupID(), BaseVehicleListWindow::vli, and VehicleListIdentifier::vtype.

## ◆ GetGroupProfitSpriteID()

SpriteID VehicleGroupWindow::GetGroupProfitSpriteID | ( | GroupID | g_id | ) | const
| inlineprivate

Get the profit sprite ID to draw for the given group.

Parameters

  g_id | Group to get profit sprite ID for.

Returns
  SpriteID to draw.

Definition at line 322 of file group_gui.cpp.

References VehicleListIdentifier::company, GetGroupNumVehicleMinAge(), GetGroupProfitLastYearMinAge(), VEHICLE_PROFIT_THRESHOLD, and BaseVehicleListWindow::vli.

Referenced by DrawGroupInfo().

## ◆ GetWidgetString()

std::string VehicleGroupWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 556 of file group_gui.cpp.

References BaseVehicleListWindow::cargo_filter_criteria, VehicleListIdentifier::company, GetGroupNumVehicle(), GetString(), Window::GetWidgetString(), IsAllGroupID(), VehicleListIdentifier::vtype, WID_GL_AVAILABLE_VEHICLES, WID_GL_CAPTION, and WID_GL_FILTER_BY_CARGO.

## ◆ OnClick()

void VehicleGroupWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 737 of file group_gui.cpp.

References _ctrl_pressed, _current_text_dir, ALL_GROUP, BaseVehicleListWindow::BuildActionDropdownList(), BaseVehicleListWindow::BuildCargoDropDownList(), BaseVehicleListWindow::cargo_filter_criteria, CcCreateGroup(), column_size, Rect::Contains(), DEFAULT_GROUP, EIT_IN_LIST, Group::flags, GUIList< T, P, F >::ForceRebuild(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::Get(), GetEncodedString(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::GetIfValid(), Scrollbar::GetScrolledItemFromWidget(), Vehicle::group_id, BaseVehicleListWindow::grouping, groups, WidgetDimensions::hsep_indent, HT_DRAG, Rect::Indent(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, INVALID_TILE, IsAllGroupID(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::IsValidID(), Window::owner, ReplaceProtection, WidgetDimensions::scaled, SelectGroup(), Window::SetDirty(), SetMouseCursorVehicle(), SetObjectToPlaceWnd(), ShowDropDownList(), ShowDropDownMenu(), ShowQuery(), Rect::Shrink(), GUIList< T, P, F >::SortType(), SPR_CURSOR_MOUSE, TD_RTL, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), GUIList< T, P, F >::ToggleSortOrder(), VEH_ROAD, VEH_TRAIN, CursorVars::vehchain, BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicle_sel, VehicleClicked(), GUIVehicleGroup::vehicles_begin, VGC_FOLD, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_GL_ALL_VEHICLES, WID_GL_AVAILABLE_VEHICLES, WID_GL_CREATE_GROUP, WID_GL_DEFAULT_VEHICLES, WID_GL_DELETE_GROUP, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_LIST_GROUP, WID_GL_LIST_VEHICLE, WID_GL_LIVERY_GROUP, WID_GL_MANAGE_VEHICLES_DROPDOWN, WID_GL_RENAME_GROUP, WID_GL_REPLACE_PROTECTION, WID_GL_SORT_BY_DROPDOWN, WID_GL_SORT_BY_ORDER, WID_GL_START_ALL, WID_GL_STOP_ALL, Window::width, and Rect::WithWidth().

## ◆ OnDragDrop()

void VehicleGroupWindow::OnDragDrop | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1012 of file group_gui.cpp.

References CursorVars::vehchain.

## ◆ OnDragDrop_Group()

void VehicleGroupWindow::OnDragDrop_Group | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inline

Definition at line 914 of file group_gui.cpp.

## ◆ OnDragDrop_Vehicle()

void VehicleGroupWindow::OnDragDrop_Vehicle | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inline

Definition at line 946 of file group_gui.cpp.

## ◆ OnDropdownSelect()

void VehicleGroupWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index,
|  | int | click_result
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1033 of file group_gui.cpp.

References CcAddVehicleNewGroup(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::IsValidID(), MassSend, NEW_GROUP, Service, BaseVehicleListWindow::SetCargoFilter(), Window::SetDirty(), GUIList< T, P, F >::SetSortType(), ShowReplaceGroupVehicleWindow(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicles, VehicleListIdentifier::vtype, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_MANAGE_VEHICLES_DROPDOWN, and WID_GL_SORT_BY_DROPDOWN.

## ◆ OnGameTick()

void VehicleGroupWindow::OnGameTick | ( |  | ) |
| inlineoverridevirtual

Called once per (game) tick.

Reimplemented from Window.

Definition at line 1085 of file group_gui.cpp.

References groups, GUIList< T, P, F >::NeedResort(), and Window::SetDirty().

## ◆ OnInvalidateData()

void VehicleGroupWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 531 of file group_gui.cpp.

References ALL_GROUP, Window::CloseChildWindows(), CloseWindowByClass(), GUIList< T, P, F >::ForceRebuild(), GUIList< T, P, F >::ForceResort(), groups, IsAllGroupID(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::IsValidID(), Window::SetDirty(), BaseVehicleListWindow::vehgroups, WC_DROPDOWN_MENU, and WC_QUERY_STRING.

## ◆ OnMouseDrag()

void VehicleGroupWindow::OnMouseDrag | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1102 of file group_gui.cpp.

References DEFAULT_GROUP, DirtyHighlightedGroupWidget(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_vehicle_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::Get(), Scrollbar::GetScrolledItemFromWidget(), groups, NEW_GROUP, Window::parent, BaseVehicleListWindow::vehicle_sel, WID_GL_DEFAULT_VEHICLES, WID_GL_LIST_GROUP, and Coord2D< T >::y.

## ◆ OnMouseLoop()

void VehicleGroupWindow::OnMouseLoop | ( |  | ) |
| inlineoverridevirtual

Called for every mouse loop run, which is at least once per (game) tick.

Reimplemented from Window.

Definition at line 729 of file group_gui.cpp.

References Window::SetDirty(), and ShowCargoIconOverlay().

## ◆ OnPaint()

void VehicleGroupWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 581 of file group_gui.cpp.

References _local_company, BuildGroupList(), Window::CloseChildWindows(), VehicleListIdentifier::company, Window::DrawWidgets(), Window::flags, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::Get(), BaseVehicleListWindow::grouping, groups, IsAllGroupID(), Window::owner, Window::RaiseWidget(), ReplaceProtection, Scrollbar::SetCount(), Window::SetWidgetsDisabledState(), GUIList< T, P, F >::SortType(), BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicles, VehicleListIdentifier::vtype, WC_DROPDOWN_MENU, WID_GL_AVAILABLE_VEHICLES, WID_GL_CREATE_GROUP, WID_GL_DELETE_GROUP, WID_GL_GROUP_BY_DROPDOWN, WID_GL_LIVERY_GROUP, WID_GL_MANAGE_VEHICLES_DROPDOWN, WID_GL_RENAME_GROUP, WID_GL_REPLACE_PROTECTION, WID_GL_SORT_BY_DROPDOWN, WID_GL_START_ALL, and WID_GL_STOP_ALL.

## ◆ OnPlaceObjectAbort()

void VehicleGroupWindow::OnPlaceObjectAbort | ( |  | ) |
| inlineoverridevirtual

The user cancelled a tile highlight mode that has been set.

Reimplemented from Window.

Definition at line 1092 of file group_gui.cpp.

References DirtyHighlightedGroupWidget(), Window::SetWidgetDirty(), and WID_GL_LIST_VEHICLE.

## ◆ OnQueryTextFinished()

void VehicleGroupWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 1020 of file group_gui.cpp.

References Rename.

## ◆ OnResize()

void VehicleGroupWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1026 of file group_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), UpdateColumnRects(), WID_GL_LIST_GROUP, and WID_GL_LIST_VEHICLE.

## ◆ SelectGroup()

void VehicleGroupWindow::SelectGroup | ( | const GroupID | g_id | ) |
| inline

Selects the specified group in the list.

Parameters

  g_id | The ID of the group to be selected

Definition at line 1162 of file group_gui.cpp.

References ALL_GROUP, BuildGroupList(), DEFAULT_GROUP, GUIList< T, P, F >::ForceRebuild(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_group_pool >::GetIfValid(), groups, Window::owner, Group::parent, Scrollbar::ScrollTowards(), Scrollbar::SetCount(), Window::SetDirty(), and BaseVehicleListWindow::vehgroups.

Referenced by OnClick(), and ShowCompanyGroupInternal().

## ◆ ShowRenameGroupWindow()

void VehicleGroupWindow::ShowRenameGroupWindow | ( | GroupID | group,
|  | bool | empty
| ) |  |
| inline

Definition at line 1135 of file group_gui.cpp.

## ◆ UnselectVehicle()

void VehicleGroupWindow::UnselectVehicle | ( | VehicleID | vehicle | ) |
| inline

Tests whether a given vehicle is selected in the window, and unselects it if necessary.

Called when the vehicle is deleted.

Parameters

  vehicle | Vehicle that is going to be deleted

Definition at line 1152 of file group_gui.cpp.

References ResetObjectToPlace().

Referenced by DeleteGroupHighlightOfVehicle().

## ◆ UpdateColumnRects()

void VehicleGroupWindow::UpdateColumnRects | ( |  | ) |
| inlineprivate

Update precalculated column rects for drawing group information.

Definition at line 286 of file group_gui.cpp.

References _current_text_dir, column_size, Rect::Indent(), WidgetDimensions::scaled, Rect::Shrink(), TD_RTL, VGC_NAME, WID_GL_LIST_GROUP, Window::width, and Rect::WithWidth().

Referenced by OnResize().

## ◆ UpdateWidgetSize()

void VehicleGroupWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 456 of file group_gui.cpp.

References BaseVehicleListWindow::BuildCargoDropDownList(), ComputeGroupInfoSize(), BaseVehicleListWindow::GetActionDropdownSize(), GetDropDownListDimension(), GetParamMaxDigits(), GetString(), GetStringBoundingBox(), GetStringListWidth(), GetVehicleListHeight(), WidgetDimensions::hsep_wide, maxdim(), Window::resize, WidgetDimensions::scaled, Window::SortButtonWidth(), tiny_step_height, VehicleListIdentifier::vtype, WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_INFO, WID_GL_LIST_GROUP, WID_GL_LIST_VEHICLE, WID_GL_MANAGE_VEHICLES_DROPDOWN, WID_GL_SORT_BY_DROPDOWN, WID_GL_SORT_BY_ORDER, and Window::width.

## Field Documentation

## ◆ column_rects

std::array<Rect, VGC_END> VehicleGroupWindow::column_rects {}
| private

Definition at line 219 of file group_gui.cpp.

## ◆ column_size

std::array<Dimension, VGC_END> VehicleGroupWindow::column_size {}
| private

Size of the columns in the group list.

Definition at line 218 of file group_gui.cpp.

Referenced by ComputeGroupInfoSize(), DrawGroupInfo(), OnClick(), and UpdateColumnRects().

## ◆ group_confirm

GroupID VehicleGroupWindow::group_confirm = GroupID::Invalid()
| private

Group awaiting delete confirmation.

Definition at line 213 of file group_gui.cpp.

## ◆ group_over

GroupID VehicleGroupWindow::group_over = GroupID::Invalid()
| private

Group over which a vehicle is dragged, GroupID::Invalid() if none.

Definition at line 212 of file group_gui.cpp.

## ◆ group_rename

GroupID VehicleGroupWindow::group_rename = GroupID::Invalid()
| private

Group being renamed, GroupID::Invalid() if none.

Definition at line 211 of file group_gui.cpp.

## ◆ group_sb

Scrollbar* VehicleGroupWindow::group_sb = nullptr
| private

Definition at line 216 of file group_gui.cpp.

## ◆ group_sel

GroupID VehicleGroupWindow::group_sel = GroupID::Invalid()
| private

Selected group (for drag/drop)

Definition at line 210 of file group_gui.cpp.

## ◆ groups

GUIGroupList VehicleGroupWindow::groups {}
| private

List of groups.

Definition at line 214 of file group_gui.cpp.

Referenced by BuildGroupList(), DrawWidget(), OnClick(), OnGameTick(), OnInvalidateData(), OnMouseDrag(), OnPaint(), and SelectGroup().

## ◆ last_overlay_state

bool VehicleGroupWindow::last_overlay_state = false
| private

Definition at line 220 of file group_gui.cpp.

## ◆ tiny_step_height

uint VehicleGroupWindow::tiny_step_height = 0
| private

Step height for the group list.

Definition at line 215 of file group_gui.cpp.

Referenced by UpdateWidgetSize().

The documentation for this class was generated from the following file:

- src/group_gui.cpp